program zs;

uses LZ4Lib, Lz4, Classes, Sysutils;


{$linklib 'liblz4.a'}
{$linklib libgcc.a}
{$linklib libkernel32.a}
{$linklib libucrt.a}


const BufSize = 40960000;



var InF, OutF: TFileStream;
    Len: Integer;
    Buf: array of Byte;


    Z: TLZ4CompressStream;

begin
 // writeln(IntToStr(  Z4_versionString ));

  InF := TFileStream.Create('lichess_db_standard_rated_2014-06.pgn', fmOpenRead);
  OutF := TFileStream.Create('pack.lz4', fmCreate);

  Z := TLZ4CompressStream.Create(OutF, 3);

  SetLength(Buf, BufSize);

  while InF.Position < InF.size do begin
    Len := InF.Read(Buf[0], BufSize);

    Z.Write(Buf[0], Len);
    //OutF.Write(Buf[0], Len);
  end;

  Z.Free;
  InF.Free;
  OutF.Free;

end.

